#ifndef _common_BoostUPath_h_
#define _common_BoostUPath_h_

#include <boost/filesystem.hpp>

#ifndef _WIN32

namespace boost
{
namespace filesystem3
{
namespace path_traits
{
  template<> struct is_pathable<uchar*>              { static const bool value = true; };
  template<> struct is_pathable<const uchar*>        { static const bool value = true; };
  template<> struct is_pathable<ustring>             { static const bool value = true; };
  template<> struct is_pathable<std::vector<uchar> > { static const bool value = true; };
  template<> struct is_pathable<std::list<uchar> >   { static const bool value = true; };

  BOOST_FILESYSTEM_DECL
  void convert(const uchar *p1, const uchar *p2,
    std::string & to,
    const codecvt_type&);

  BOOST_FILESYSTEM_DECL
  void convert(const char *p1, const char *p2,
    ustring & to,
    const codecvt_type &cvt);

  inline
  void convert(const std::string &from,
    ustring & to,
    const codecvt_type&)
  {
    to += USTR(from);
  }

  inline
  void convert(const ustring &from,
    std::string & to,
    const codecvt_type&)
  {
    to += STR(from);
  }

  inline
  void convert(const uchar *p1, const uchar *p2,
    std::string & to,
    const codecvt_type&)
  {
    BOOST_ASSERT(p1);
    BOOST_ASSERT(p2);
  
    ustring s;
    s.assign(p1, p2-p1);
    
    to += STR(s);
  }

  inline
  void convert(const char *p1, const char *p2,
    ustring & to,
    const codecvt_type &cvt)
  {
    std::string s;
    convert(p1,p2,s,cvt);
    to += USTR(s);
  }
}
}
}

#endif //_WIN32

#endif // _common_BoostUPath_h_
